#ifndef MAKER_UPDATER_HPP_INCLUDED
#   define MAKER_UPDATER_HPP_INCLUDED

#   include <com/runner.hpp>
#   include <maker/ocean.hpp>
#   include <math/math.hpp>

namespace com { struct Frame; }

namespace mak {

struct Updater : public com::Runner
{
    static inline std::string self_name() { return "updater.run"; }

    Updater();
    ~Updater() override;

    void next_round() override;

protected:

    Ocean ocean {16U, 2.0f, 9.81f, { 2.0f, 3.0f }, 5.0f };

    gfx::Buffer* plane_buffer = nullptr;
    gfx::Buffer::PositionsVec default_plane_positions;

    void initialize() override;
    void release() override;
};

}

#endif
